<?php
/*
 * $Id: server_manager.lib.php,v 1.1.1.1 2008/06/11 02:14:11 ikuma Exp $
 *
 * Server Manager by ADCOOP
 */

// include the setup script
include('server_manager_setup.php');


/**
 * server manager application library
 * 
 */
class ServerManager {
  // database object
  var $sql = null;
  // xml data
  var $xml = null;
  // xslt
  var $xsl = null;
  // user class object
  var $user_class = null;
  // html title
  var $title = SERVER_MANAGER_TITLE_NAME;
  /**
   * class constructor
   */
  function ServerManager() {
    $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "";
    // instantiate the sql object
    $this->sql =& new ServerManager_SQL;
  }
  function fncXmlOutput($convert=true){
    header("Content-type: application/xml");
    print '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
    if($this->xsl == "" || !file_exists(SERVER_MANAGER_XSL_DIR.$this->xsl)){
      //exit("XSLT File Loading Error...File Not Found.(".$this->xsl.")");
      $this->xml .= "<!-- XSLT File Loading Error...File Not Found.(".$this->xsl.") -->\n";
    }else{
      if($convert){
        print '<?xml-stylesheet type="text/xsl" href="'.'xslt/'.$this->xsl.'" ?>'."\n";
      }
    }
    print $this->xml;
    //@file_put_contents("/home/server_manager/public_html/libs/xml.txt",$this->xml);
    exit;
  }
  function fncDisplayWithXml($xml,$template,$header=""){
    $this->xsl  = null;
    $this->xml  = null;
    $this->xml .= "<ServerManager>\n";
    $this->xml .= '<Header title="'.$this->title.'">'."\n";
    if($header != ""){
      $this->xml .= $header;
    }
    $this->xml .= "</Header>\n";
    $this->xml .= $xml;
    $this->xml .= "</ServerManager>\n";
    $this->xsl  = $template;
    $this->fncXmlOutput();
  }
  function fncDisplayWithoutXml($template,$header=""){
    $this->xsl  = null;
    $this->xml  = null;
    $this->xml .= "<ServerManager>\n";
    $this->xml .= '<Header title="'.$this->title.'">'."\n";
    if($header != ""){
      $this->xml .= $header;
    }
    $this->xml .= "</Header>\n";
    $this->xml .= "</ServerManager>\n";
    $this->xsl  = $template;
    $this->fncXmlOutput();
  }
  function fncArray2Xml($array,$pre="Records",$key=""){
    if(!is_array($array)){
      return "";
    }
    $xml = "";
    foreach($array as $k=>$val){
      if($key != ""){
        $xml .= "<".$pre." ".$key."=\"".$val[$key]."\">\n";
      }else{
        $xml .= "<".$pre.">\n";
      }
      $buff = array_keys($val);
      for($i=0;$i < count($val); $i++){
        if($buff[$i] != $key){
          if($val[$buff[$i]] != ""){
            if(!is_numeric($val[$buff[$i]])){
              $xml .= "  <".$buff[$i]."><![CDATA[".$val[$buff[$i]]."]]></".$buff[$i].">\n";
            }else{
              $xml .= "  <".$buff[$i].">".$val[$buff[$i]]."</".$buff[$i].">\n";
            }
          }else{
            $xml .= "  <".$buff[$i]." />\n";
          }
        }
      }
      $xml.= "</".$pre.">\n";
    }
    return $xml;
  }


    /**
    * get the attest 
    *
    * @param array $formvars the form variables
    */
    function isValidLogin($formvars = array()) {
      $this->xml = null;
      $this->xsl = null;

      //check that the user is calling the page from the login form and not accessing it directly
      if (!isset($formvars['username']) || !isset($formvars['password'])) { 
          $this->fncDisplayWithoutXml('login_form.php');
      } elseif (empty($formvars['username']) || empty($formvars['password'])) { 
          $this->fncDisplayWithoutXml('login_form.php');
      } else {
          //add slashes to the username and md5() the password 
          $user = addslashes($formvars['username']); 
          $pass = md5($formvars['password']); 

          $query  = "";
          $query .= "select * from mst_usr where username = '$user' and password = '$pass'";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          //valid user
          if ($this->sql->record[0]["class_cd"] > 0) {
             //register a variable
              $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd']     = $this->sql->record[0]["usr_cd"];
              $_SESSION[SERVER_MANAGER_SES_NAME]['username']   = $this->sql->record[0]["username"];
              $_SESSION[SERVER_MANAGER_SES_NAME]['user_class'] = $this->sql->record[0]["class_cd"];
              $this->fncDisplayWithoutXml('main_menu.php');
          } elseif (($this->sql->record[0]["class_cd"] == 0) && ($this->sql->record[0]["usr_cd"] != "")){
              //invalid class
              $this->fncDisplayWithoutXml('invalid_class_form.php');
          } else {
              //invalid user
              $this->fncDisplayWithoutXml('invalid_user_form.php');
          }
      }
    }


    /**
     * display serverbooks
     *
     * @param array $data the serverbook data
     */
    function displayServerBook($xml = "") {
      $this->fncDisplayWithXml($xml,'serverbook.php');
    }


    /**
     * get all the serverbook entries
     */
    function getServerEntries($formvars = array()) {
      $userclass = $_SESSION[SERVER_MANAGER_SES_NAME]["user_class"];
      $disp_flag = $formvars["flg"];
      $xml = "";
      if($userclass > 4){
        $buff[0] = $formvars;
        $xml .= $this->fncArray2Xml($buff,"Entry");
        if($disp_flag == 'dsp'){
          $query = "select * from mst_server order by srv_name";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        } else {
          $query = "select * from mst_server where disp_flag = 't' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        }
      } else {
        if($disp_flag == 'dsp'){
          $query = "select * from mst_server where router_flag = 'f' order by srv_name";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        } else {
          $query = "select * from mst_server where router_flag = 'f' and disp_flag = 't' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        }
      }
      $xml .= $this->fncArray2Xml($this->sql->record,"Records","srv_cd");
      return $xml;
    }


    /**
     * get the serverbook entries
     */
    function getServerSearchEntries($formvars = array()) {
       $xml  = "";
       // user class 
       $userclass = $_SESSION[SERVER_MANAGER_SES_NAME]["user_class"];
       $status                    = $formvars["status"];
       $srch_srv_name             = $formvars["srch_srv_name"];
       $srch_eth0_ipaddr          = $formvars["srch_eth0_ipaddr"];
       $srch_default_gateway      = $formvars["srch_default_gateway"];
       $srch_primary_nameserver   = $formvars["srch_primary_nameserver"];
       $srch_secondary_nameserver = $formvars["srch_secondary_nameserver"];
       $srch_eth1_ipaddr          = $formvars["srch_eth1_ipaddr"];
       $srch_eth2_ipaddr          = $formvars["srch_eth2_ipaddr"];
       $srch_wantLogCheck         = $formvars["srch_wantLogCheck"];
       $srch_backupSvr            = $formvars["srch_backupSvr"];
       $srch_hourly_flag          = $formvars["srch_hourly_flag"];
       $buff[0] = $formvars;
       $xml .= $this->fncArray2Xml($buff,"Entry");
      if($userclass > 4){
        if($status == 'like_srv_name'){
          $query = "select * from mst_server where srv_name like '$srch_srv_name%' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        } elseif($status == 'like_eth0_ipaddr') {
          $query = "select * from mst_server where eth0_ipaddr like '$srch_eth0_ipaddr%' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        } elseif($status == 'like_default_gateway') {
          $query = "select * from mst_server where default_gateway like '$srch_default_gateway%' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        } elseif($status == 'like_primary_nameserver') {
          $query = "select * from mst_server where primary_nameserver like '$srch_primary_nameserver%' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        } elseif($status == 'like_secondary_nameserver') {
          $query = "select * from mst_server where secondary_nameserver like '$srch_secondary_nameserver%' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        } elseif($status == 'like_eth1_ipaddr') {
          $query = "select * from mst_server where eth1_ipaddr like '$srch_eth1_ipaddr%' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        } elseif($status == 'like_eth2_ipaddr') {
          $query = "select * from mst_server where eth2_ipaddr like '$srch_eth2_ipaddr%' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);

        } elseif($status == 'like_wantLogCheck') {
          if($srch_wantLogCheck == "t"){
            $query = "select * from mst_server where wantlogcheck = 't' order by srv_name ";
            $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          }elseif($srch_wantLogCheck == "f"){
            $query = "select * from mst_server where wantlogcheck = 'f' order by srv_name ";
            $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          }else{
            $query = "select * from mst_server where srv_cd is null ";
            $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          }
        } elseif($status == 'like_backupSvr') {
          if($srch_backupSvr == "t"){
            $query = "select * from mst_server where backupsvr = 't' order by srv_name ";
            $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          }elseif($srch_backupSvr == "f"){
            $query = "select * from mst_server where backupsvr = 'f' order by srv_name ";
            $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          }else{
            $query = "select * from mst_server where srv_cd is null ";
            $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          }
        } elseif($status == 'like_hourlyCheck') {
          if($srch_hourly_flag == "t"){
            $query = "select * from mst_server where hourly_flag = 't' order by srv_name ";
            $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          }elseif($srch_hourly_flag == "f"){
            $query = "select * from mst_server where hourly_flag = 'f' order by srv_name ";
            $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          }else{
            $query = "select * from mst_server where srv_cd is null ";
            $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          }
        } else {
          $query = "select * from mst_server where router_flag = 'f' and disp_flag = 't' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        }
      }
      $xml .= $this->fncArray2Xml($this->sql->record,"Records","srv_cd");
      return $xml;
    }


    /**
     * lock status update
     */
    function lockServerEntriesAF($disp_flg,$formvars) {
      $userclass                 = $_SESSION[SERVER_MANAGER_SES_NAME]["user_class"];
      $ostatus                   = $formvars["ostatus"];
      $srch_srv_name             = $formvars["hsrch_srv_name"];
      $srch_eth0_ipaddr          = $formvars["hsrch_eth0_ipaddr"];
      $srch_default_gateway      = $formvars["hsrch_default_gateway"];
      $srch_primary_nameserver   = $formvars["hsrch_primary_nameserver"];
      $srch_secondary_nameserver = $formvars["hsrch_secondary_nameserver"];
      $srch_eth1_ipaddr          = $formvars["hsrch_eth1_ipaddr"];
      $srch_eth2_ipaddr          = $formvars["hsrch_eth2_ipaddr"];
      $srch_wantLogCheck         = $formvars["hsrch_wantLogCheck"];
      $srch_backupSvr            = $formvars["hsrch_backupSvr"];
      $srch_hourly_flag          = $formvars["hsrch_hourly_flag"];

      if($userclass > 4){
        if($disp_flg == 'dsp'){
          $query = "update mst_server set lock_flag = 'f' ";
        } else {
          $query = "update mst_server set lock_flag = 'f' where disp_flag = 't' ";
        }
      } else {
        if($disp_flg == 'dsp'){
          $query = "update mst_server set lock_flag = 'f' where router_flag = 'f' ";
        } else {
          $query = "update mst_server set lock_flag = 'f' where router_flag = 'f' and disp_flag = 't' ";
        }
      }

      if($ostatus == 'like_srv_name'){
        $query .= "and srv_name like '$srch_srv_name%' ";
      } elseif($ostatus == 'like_eth0_ipaddr') {
        $query .= "and eth0_ipaddr like '$srch_eth0_ipaddr%' ";
      } elseif($ostatus == 'like_default_gateway') {
        $query .= "and default_gateway like '$srch_default_gateway%' ";
      } elseif($ostatus == 'like_primary_nameserver') {
        $query .= "and primary_nameserver like '$srch_primary_nameserver%' ";
      } elseif($ostatus == 'like_secondary_nameserver') {
        $query .= "and secondary_nameserver like '$srch_secondary_nameserver%' ";
      } elseif($ostatus == 'like_eth1_ipaddr') {
        $query .= "and eth1_ipaddr like '$srch_eth1_ipaddr%' ";
      } elseif($ostatus == 'like_eth2_ipaddr') {
        $query .= "and eth2_ipaddr like '$srch_eth2_ipaddr%' ";
      } elseif($ostatus == 'like_wantLogCheck') {
        if($srch_wantLogCheck == "t"){
          $query .= "and wantlogcheck = 't' ";
        }elseif($srch_wantLogCheck == "f"){
          $query .= "and wantlogcheck = 'f' ";
        }
      } elseif($ostatus == 'like_backupSvr') {
        if($srch_backupSvr == "t"){
          $query .= "and backupsvr = 't' ";
        }elseif($srch_backupSvr == "f"){
          $query .= "and backupsvr = 'f' ";
        }
      } elseif($ostatus == 'like_hourlyCheck') {
        if($srch_hourly_flag == "t"){
          $query .= "and hourly_flag = 't' ";
        }elseif($srch_hourly_flag == "f"){
          $query .= "and hourly_flag = 'f' ";
        }
      }

      //@file_put_contents("/home/server_manager/public_html/libs/sql.txt",$ostatus."\n".$formvars."\n".$query);

      return $this->sql->query($query);
    }


    function lockServerEntries($disp_flg,$srv_cd) {
      $userclass = $_SESSION[SERVER_MANAGER_SES_NAME]["user_class"];
      if($userclass > 4){
        if($disp_flg == 'dsp'){
          $query = sprintf("update mst_server set lock_flag = 't' where srv_cd = '%s' ",pg_escape_string($srv_cd));
        } else {
          $query = sprintf("update mst_server set lock_flag = 't' where srv_cd = '%s' and disp_flag = 't' ",pg_escape_string($srv_cd));
        }
      } else {
        if($disp_flg == 'dsp'){
          $query = sprintf("update mst_server set lock_flag = 't' where srv_cd = '%s' and router_flag = 'f' " ,pg_escape_string($srv_cd));
        } else {
          $query = sprintf("update mst_server set lock_flag = 't' where srv_cd = '%s' and router_flag = 'f' and disp_flag = 't' ",pg_escape_string($srv_cd));
        }
      }
      return $this->sql->query($query);
    }


    /**
     * get one of the serverbook entries 
     */
    function getOneServerEntries($formvars = array()) {
      $srv_cd = $formvars["srv_cd"];
      $query  = "";
      $query .= "select srv_cd,srv_name,eth0_ipaddr,default_gateway,primary_nameserver,secondary_nameserver,eth1_ipaddr,eth2_ipaddr,os ";
      $query .= "from mst_server where srv_cd = '$srv_cd'";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      $xml = $this->fncArray2Xml($buff,"SrvInfo","srv_cd");
      return $xml;
    }


    /**
     * display the serverbook entry form
     *
     * @param array $formvars the form variables
     */
    function displayServerForm($formvars = array()) {
      $buff[0] = $formvars;
      $xml = $this->fncArray2Xml($buff,"Records");
      $this->fncDisplayWithXml($xml,'add_serverbook_form.php');
    }


    /**
     * fix up form data if necessary
     *
     * @param array $formvars the form variables
     */
    function mungeServerFormData(&$formvars) {
        // trim off excess whitespace
        $formvars['srv_name']             = trim($formvars['srv_name']);
        $formvars['eth0_ipaddr']          = trim($formvars['eth0_ipaddr']);
        $formvars['eth0_network']         = trim($formvars['eth0_network']);
        $formvars['eth0_netmask']         = trim($formvars['eth0_netmask']);
        $formvars['eth0_broadcast']       = trim($formvars['eth0_broadcast']);
        $formvars['default_gateway']      = trim($formvars['default_gateway']);
        $formvars['primary_nameserver']   = trim($formvars['primary_nameserver']);
        $formvars['secondary_nameserver'] = trim($formvars['secondary_nameserver']);
        $formvars['os']                   = trim($formvars['os']);
        $formvars['eth1_ipaddr']          = trim($formvars['eth1_ipaddr']);
        $formvars['eth1_network']         = trim($formvars['eth1_network']);
        $formvars['eth1_netmask']         = trim($formvars['eth1_netmask']);
        $formvars['eth1_broadcast']       = trim($formvars['eth1_broadcast']);
        $formvars['eth2_ipaddr']          = trim($formvars['eth2_ipaddr']);
        $formvars['eth2_network']         = trim($formvars['eth2_network']);
        $formvars['eth2_netmask']         = trim($formvars['eth2_netmask']);
        $formvars['eth2_broadcast']       = trim($formvars['eth2_broadcast']);
    }


    /**
     * test if form information is valid
     *
     * @param array $formvars the form variables
     */
    function isValidServerForm($formvars) {
      // test if "srv_name" is empty
      if(strlen($formvars['srv_name']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'srv_name';
        return false; 
      }
      // test if "eth0_ipaddr" is empty
      if(strlen($formvars['eth0_ipaddr']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'eth0_ipaddr';
        return false; 
      }
      // test if "eth0_network" is empty
      if(strlen($formvars['eth0_network']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'eth0_network';
        return false; 
      }
      // test if "eth0_netmask" is empty
      if(strlen($formvars['eth0_netmask']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'eth0_netmask';
        return false; 
      }
      // test if "eth0_broadcast" is empty
      if(strlen($formvars['eth0_broadcast']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'eth0_broadcast';
        return false; 
      }
      // test if "wantlogcheck" is t or f
      if(!(($formvars['wantlogcheck'] == 't') || ($formvars['wantlogcheck'] == 'f'))){
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'wantlogcheck';
        return false; 
      }
      // test if "tripwirecheck" is t or f
      if(!(($formvars['tripwire_flag'] == 't') || ($formvars['tripwire_flag'] == 'f'))){
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'tripwire_flag';
        return false; 
      }
      // test if "backupsvr" is t or f
      if(!(($formvars['backupsvr'] == 't') || ($formvars['backupsvr'] == 'f'))){
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'backupsvr';
        return false; 
      }
      // test if "disp_flag" is t or f
      if(!(($formvars['disp_flag'] == 't') || ($formvars['disp_flag'] == 'f'))){
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'disp_flag';
        return false; 
      }
      // test if "router_flag" is t or f
      if(!(($formvars['router_flag'] == 't') || ($formvars['router_flag'] == 'f'))){
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'router_flag';
        return false; 
      }
      // test if "hourly_flag" is t or f
      if(!(($formvars['hourly_flag'] == 't') || ($formvars['hourly_flag'] == 'f'))){
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'hourly_flag';
        return false; 
      }
      // form passed validation
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      return true;
    }


    /**
     * get a new max srv_cd
     *
     * @param array $formvars the form variables
     */
    function getMaxServerCD() {
      // select max srv_cd
      $query = "select max(srv_cd) + 1 as max_srv_cd from mst_server";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      if($this->sql->record[0]['max_srv_cd'] == ''){
        $this->sql->record[0]['max_srv_cd'] = 1;
        return $this->sql->record;
      }else{
        return $this->sql->record;
      }
    }


    /**
     * add a new serverbook entry
     *
     * @param array $formvars the form variables
     */
    function addServerEntry($formvars, $data = array()) {
        $max_srv_cd = $data[0]['max_srv_cd'];
        $_query = sprintf("insert into mst_server values('%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s')",
                $max_srv_cd,
                pg_escape_string($formvars['srv_name']),
                pg_escape_string($formvars['eth0_ipaddr']),
                pg_escape_string($formvars['eth0_network']),
                pg_escape_string($formvars['eth0_netmask']),
                pg_escape_string($formvars['eth0_broadcast']),
                pg_escape_string($formvars['default_gateway']),
                pg_escape_string($formvars['primary_nameserver']),
                pg_escape_string($formvars['secondary_nameserver']),
                pg_escape_string($formvars['os']),
                pg_escape_string($formvars['eth1_ipaddr']),
                pg_escape_string($formvars['eth1_network']),
                pg_escape_string($formvars['eth1_netmask']),
                pg_escape_string($formvars['eth1_broadcast']),
                pg_escape_string($formvars['eth2_ipaddr']),
                pg_escape_string($formvars['eth2_network']),
                pg_escape_string($formvars['eth2_netmask']),
                pg_escape_string($formvars['eth2_broadcast']),
                $formvars['wantlogcheck'],
                $formvars['backupsvr'],
                $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                NOW,
                $formvars['disp_flag'],
                $formvars['router_flag'],
                t,  // lock_flag
                $formvars['hourly_flag'],
                $formvars['tripwire_flag']
        );
        return $this->sql->query($_query);
    }


    /**
     * get one of the serverbook entries All
     */
    function getOneServerEntriesAll($formvars = array()) {
      $xml = "";
      $buff[0] = $formvars;
      $xml .= $this->fncArray2Xml($buff,"Post");
      $srv_cd = $formvars["srv_cd"];
      $query = "select * from mst_server where srv_cd = '$srv_cd'";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $xml .= $this->fncArray2Xml($this->sql->record,"Records","srv_cd");
      return $xml;
    }


    /**
     * display one of the serverbook entries 
     *
     * @param array $data the serverbook data
     */
    function displayServerEditForm($xml = "") {
      $this->fncDisplayWithXml($xml,'edit_serverbook_form.php');
    }


    /**
     * edit the serverbook entry
     *
     * @param array $formvars the form variables
     */
    function confirmServerEntry($formvars) {

        $_query = sprintf("update mst_server set srv_name             = '%s',
                                                 eth0_ipaddr          = '%s',
                                                 eth0_network         = '%s',
                                                 eth0_netmask         = '%s',
                                                 eth0_broadcast       = '%s',
                                                 default_gateway      = '%s',
                                                 primary_nameserver   = '%s',
                                                 secondary_nameserver = '%s',
                                                 os                   = '%s',
                                                 eth1_ipaddr          = '%s',
                                                 eth1_network         = '%s',
                                                 eth1_netmask         = '%s',
                                                 eth1_broadcast       = '%s',
                                                 eth2_ipaddr          = '%s',
                                                 eth2_network         = '%s',
                                                 eth2_netmask         = '%s',
                                                 eth2_broadcast       = '%s',
                                                 wantlogcheck         = '%s',
                                                 backupsvr            = '%s',
                                                 usr_cd               = '%s',
                                                 disp_flag            = '%s',
                                                 router_flag          = '%s',
                                                 last_date            = '%s',
                                                 hourly_flag          = '%s',
                                                 tripwire_flag        = '%s'
                           where srv_cd = '%s'",
                          pg_escape_string($formvars['srv_name']),
                          pg_escape_string($formvars['eth0_ipaddr']),
                          pg_escape_string($formvars['eth0_network']),
                          pg_escape_string($formvars['eth0_netmask']),
                          pg_escape_string($formvars['eth0_broadcast']),
                          pg_escape_string($formvars['default_gateway']),
                          pg_escape_string($formvars['primary_nameserver']),
                          pg_escape_string($formvars['secondary_nameserver']),
                          pg_escape_string($formvars['os']),
                          pg_escape_string($formvars['eth1_ipaddr']),
                          pg_escape_string($formvars['eth1_network']),
                          pg_escape_string($formvars['eth1_netmask']),
                          pg_escape_string($formvars['eth1_broadcast']),
                          pg_escape_string($formvars['eth2_ipaddr']),
                          pg_escape_string($formvars['eth2_network']),
                          pg_escape_string($formvars['eth2_netmask']),
                          pg_escape_string($formvars['eth2_broadcast']),
                          $formvars['wantlogcheck'],
                          $formvars['backupsvr'],
                          $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                          $formvars['disp_flag'],
                          $formvars['router_flag'],
                          NOW,
                          $formvars['hourly_flag'],
                          $formvars['tripwire_flag'],
                          $formvars['srv_cd']
        );

        return $this->sql->query($_query);
        
    }


     /**
     * get  the server install log 
     */
    function isServerInstallLog($formvars = array()) {
        $srv_cd = $formvars["srv_cd"];
        $query = "select count(*) as count from fil_router_log where srv_cd = '$srv_cd' ";
        $query .= "union select count(*) as count from fil_server_memo where srv_cd = '$srv_cd' ";
        $query .= "union select count(*) as count from mst_server_usr where srv_cd = '$srv_cd' ";
        $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        if(($this->sql->record[0]["count"] == 0 ) && ($this->sql->record[1]["count"] == 0 ) && ($this->sql->record[2]["count"] == 0 )){
           return TRUE;
        } else {
           return FALSE;
        }
    }


    /**
     * delete the serverbook entry
     *
     * @param array $formvars the form variables
     */
    function deleteServerEntry($formvars = array()) {
        $srv_cd = $formvars["srv_cd"];
        $_query = sprintf("delete from mst_server where srv_cd = '$srv_cd'");
        return $this->sql->query($_query);
    }


    /**
    * display the invalid delete server
    */
    function displayDeleteServerFailed() {
      $this->fncDisplayWithoutXml('invalid_delete_server_form.php');
    }

     /**
     * display the serverbook for userbook
     *
     * @param array $data the serverbook data
     */
    function displayServerUserBook($xml = "") {
      $this->fncDisplayWithXml($xml,'user_serverbook.php');
    }


     /**
     * get the server user list 
     */
    function getServerUserList($formvars = array()) {
      $srv_cd = $formvars["srv_cd"];
      if($_SESSION[SERVER_MANAGER_SES_NAME]["user_class"] > 4 ){
        $query = "select * from mst_server_usr where srv_cd = '$srv_cd' order by srv_usr";
        $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      } else {
        $query = "select * from mst_server_usr where srv_cd = '$srv_cd' and srv_usr <> 'root' and srv_usr <> 'postgres' order by srv_usr";
        $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      }
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"Records","srv_usr_cd");
    }


     /**
     * display the server user list 
     *
     * @param array $data the serverbook data
     */
    function displayServerUserList($xml = "") {
      $this->fncDisplayWithXml($xml,'server_user_list.php');
    }


    /**
     * lock the server user entry
     */
    function lockServerUserEntryAF($srv_cd) {
      $_query = sprintf("update mst_server_usr set lock_flag = null where srv_cd = '%s' ",pg_escape_string($srv_cd));
      return $this->sql->query($_query);
    }


    function lockServerUserEntry($srv_usr_cd) {
      $_query = sprintf("update mst_server_usr set lock_flag = 't' where srv_usr_cd = '%s' ",pg_escape_string($srv_usr_cd));
      return $this->sql->query($_query);
    }


     /**
     * display the server user adding form
     *
     */
    function displayServerUserAddForm($xml = "") {
      $this->fncDisplayWithXml($xml,'add_server_user_form.php');
    }


    /**
     * fix up form data if necessary
     *
     * @param array $formvars the form variables
     */
    function mungeServerUserFormData(&$formvars) {
      // trim off excess whitespace
      $formvars['srv_usr']       =  trim($formvars['srv_usr']);
      $formvars['srv_usr_pass']  =  trim($formvars['srv_usr_pass']);
    }


    /**
     * test if form information is valid
     *
     * @param array $formvars the form variables
     */
    function isValidServerUserForm($formvars) {
      if(strlen($formvars['srv_usr']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'srv_usr';
        return false; 
      }
      if(strlen($formvars['srv_usr_pass']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'srv_usr_pass';
        return false; 
      }
      if($_SESSION[SERVER_MANAGER_SES_NAME]["user_class"] < 5 ){
        // form passed validation
        if($formvars['srv_usr'] == 'root') {
          $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'srv_usr_root';
          return false; 
        }
        if($formvars['srv_usr'] == 'postgres') {
          $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'srv_usr_postgres';
          return false; 
        }
      }
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      return true;
    }


    /**
     * get a new max srv_usr_cd
     *
     * @param array $formvars the form variables
     */
    function getMaxServerUser() {
      // select max srv_usr_cd
      $query = "select max(srv_usr_cd) + 1 as max_srv_usr_cd from mst_server_usr";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      if($this->sql->record[0]['max_srv_usr_cd'] == ''){
        $this->sql->record[0]['max_srv_usr_cd'] = 1;
        return $this->sql->record;
      }else{
        return $this->sql->record;
      }
    }


    /**
     * add a new server user entry
     *
     * @param array $formvars the form variables
     */
    function addServerUserEntry($formvars, $data = array()) {
      // assign the data vars       
      $max_srv_usr_cd = $data[0]['max_srv_usr_cd'];
      $_query = sprintf("insert into mst_server_usr values('%s','%s','%s','%s','%s','%s','%s')",
                $max_srv_usr_cd,
                pg_escape_string($formvars["srv_usr"]),
                pg_escape_string($formvars["srv_usr_pass"]),
                pg_escape_string($formvars["srv_cd"]),
                $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                NOW,
                t // lock_flag
      );
      return $this->sql->query($_query);
    }


    /**
     * get one of the server user
     */
    function getServerUserEntries($formvars = array()) {
      $srv_usr_cd = $formvars["srv_usr_cd"];
      $query = "select * from mst_server_usr where srv_usr_cd = '$srv_usr_cd' ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"Records","srv_cd");
    }


    /**
     * display one of the server user
     *
     * @param array $data the serverbook data
     */
    function displayServerUserEditForm($xml = "") {
      $this->fncDisplayWithXml($xml,'edit_server_user_form.php');
    }


    /**
     * edit the server user entry
     *
     * @param array $formvars the form variables
     */
    function confirmServerUserEntry($formvars) {
      $_query = sprintf("update mst_server_usr set srv_usr       = '%s',
                                                   srv_usr_pass  = '%s',
                                                   last_date     = NOW(),
                                                   usr_cd        = '%s'
                          where srv_usr_cd = '%s'",
                          pg_escape_string($formvars['srv_usr']),
                          pg_escape_string($formvars['srv_usr_pass']),
                          $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                          pg_escape_string($formvars['srv_usr_cd'])
        );
        return $this->sql->query($_query);
    }


    /**
     * delete the server user
     *
     * @param array $formvars the form variables
     */
    function deleteServerUserEntry($formvars = array()) {
      $srv_usr_cd = $formvars["srv_usr_cd"];
      $_query = sprintf("delete from mst_server_usr where srv_usr_cd = '$srv_usr_cd'");
      return $this->sql->query($_query);
    }


     /**
     * display the Set Date For Daily Server logs
     *
     */
    function setDateForDailySever() {
      // assign the date vars
      $header  = "";
      $header .= "<today>".date('Y-m-d')."</today>";
      $this->fncDisplayWithoutXml('set_date_form.php',$header);
    }


    /**
     * get the daily server log entries
     */
    function getDailyServerLogs($formvars = array(),$mode) {
      switch($mode){
        case "T":
          $rcv_date   = $formvars["reg_date_t"];
          $table_name = "logs_tripwire";
          // get the server master entries
          $srv_data = array();
          $query  = ""; 
          $query .= "select srv_cd,srv_name,eth0_ipaddr from mst_server where tripwire_flag = 't' and router_flag = 'f' order by srv_name ";
          $this->sql->query($query,SQL_ALL,SQL_ASSOC);
          $srv_data = $this->sql->record;
          // get the server log entries
          $offset = 0;
          $new_key = "";
          $old_key = $new_key;
          foreach($srv_data as $k=>$v){
            preg_match("/^([^\(]*[\.jp|\.com]).*$/",$v["srv_name"],$matchs); // delete after srv_name
            $new_key = $matchs[1];
            if($new_key == $old_key){ // when same srv_name exist
              $offset++;              // log must be one to one
            }else{
              $offset = 0;
            }
            $logdata = null;
            $query  = "";  // subject priority
            $query .= "select sirial,subject,mail_log,rcv_date,set_cd,set_date,memo_cd,memo_date from $table_name ";
            $query .= "where (rcv_date::date = '$rcv_date'::date or set_date::date = '$rcv_date'::date) and srv_name = '".$matchs[1]."' order by sirial offset $offset limit 1 ";
            $this->sql->query($query,SQL_INIT,SQL_ASSOC);
            $logdata =  $this->sql->record;
            $srv_data[$k]["sirial"] = $logdata["sirial"];
            // when log empty
            if($logdata["sirial"] == ""){
              // get max serial
              $query  = "";
              $query .= "select coalesce(max(sirial)+1,1) as max_sirial from $table_name ";
              $this->sql->query($query,SQL_INIT,SQL_ASSOC);
              $data =  $this->sql->record;
              $max_sirial = $data['max_sirial'];
              $_query = sprintf("insert into %s (sirial,srv_name,set_cd,set_date)values('%s','%s','%s','%s')",
                      $table_name,
                      $max_sirial,
                      $matchs[1],
                      $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                      pg_escape_string($rcv_date)
              );
              $this->sql->query($_query);
              $srv_data[$k]["sirial"]   = $max_sirial;
              $srv_data[$k]["set_cd"]   = $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'];
              $srv_data[$k]["set_date"] = pg_escape_string($rcv_date);
            }
            // when first display
            if($srv_data[$k]["set_date"] == ""){
              $_query = sprintf("update %s set set_cd = '%s',set_date = '%s' where sirial = %s ",
                      $table_name,
                      $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                      pg_escape_string($rcv_date),
                      $logdata["sirial"]
              );
              $this->sql->query($_query);
              $srv_data[$k]["set_cd"]   = $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'];
              $srv_data[$k]["set_date"] = pg_escape_string($rcv_date);
            }else{
              $srv_data[$k]["set_cd"]   = $logdata["set_cd"];
              $srv_data[$k]["set_date"] = $logdata["set_date"];
            }

            $fs_err = "";
            $buff = explode(" ",$logdata["subject"]);
            if($buff[0] != "[integrit]"){
              $srv_data[$k]["V"] = preg_replace("/V:/","",$buff[3]);
              $srv_data[$k]["S"] = preg_replace("/S:/","",$buff[4]);
              $srv_data[$k]["A"] = preg_replace("/A:/","",$buff[5]);
              $srv_data[$k]["R"] = preg_replace("/R:/","",$buff[6]);
              $srv_data[$k]["C"] = preg_replace("/C:/","",$buff[7]);
              $buff  = explode("\n",$logdata["mail_log"]);
              foreach($buff as $b){
                if(preg_match("/.*File system error.*$/",$b)){
                  $fs_err = "Err.";
                  break;
                }
              }
            }else{
              $srv_data[$k]["V"] = "-";
              $srv_data[$k]["S"] = "-";
              $srv_data[$k]["A"] = "-";
              $srv_data[$k]["R"] = "-";
              $srv_data[$k]["C"] = "-";
            }

            $srv_data[$k]["F"] = $fs_err;
            $srv_data[$k]["rcv_date"]  = $logdata["rcv_date"];
            $srv_data[$k]["memo_cd"]   = $logdata["memo_cd"];
            $srv_data[$k]["memo_date"] = $logdata["memo_date"];
            $old_key = $new_key;
          }
          return $this->fncArray2Xml($srv_data,"Records","sirial");
        case "L":
          $rcv_date = $formvars["reg_date_l"];
          $table_name = "logs_logwatch";
          $srv_data = array();
          $this->sql->query("select srv_cd,srv_name,eth0_ipaddr from mst_server where wantlogcheck = 't' and router_flag = 'f' order by srv_name ",
                           SQL_ALL,
                           SQL_ASSOC
                    );
          $srv_data = $this->sql->record;
          $offset = 0;
          $new_key = "";
          $old_key = $new_key;
          foreach($srv_data as $k=>$v){
            preg_match("/^([^\(]*[\.jp|\.com]).*$/",$v["srv_name"],$matchs);
            $new_key = $matchs[1];
            if($new_key == $old_key){
              $offset++;
            }else{
              $offset = 0;
            }
            $logdata = null;
            $this->sql->query(
                          "select sirial,subject,mail_log,rcv_date,set_cd,set_date,memo_cd,memo_date from $table_name where (rcv_date::date = '$rcv_date'::date or set_date::date = '$rcv_date'::date) and srv_name = '".$matchs[1]."' order by sirial offset $offset limit 1 ",
                           SQL_INIT,
                           SQL_ASSOC
                    );
            $logdata =  $this->sql->record;
            $srv_data[$k]["sirial"]    = $logdata["sirial"];

            // when log empty
            if($logdata["sirial"] == ""){
              // select max serial
              $this->sql->query("select coalesce(max(sirial)+1,1) as max_sirial from $table_name",SQL_INIT,SQL_ASSOC);
              $data =  $this->sql->record;
              $max_sirial = $data['max_sirial'];
              $_query = sprintf("insert into %s (sirial,srv_name,set_cd,set_date)values('%s','%s','%s','%s')",
                      $table_name,
                      $max_sirial,
                      $matchs[1],
                      $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                      pg_escape_string($rcv_date)
              );
              $this->sql->query($_query);
              $srv_data[$k]["sirial"]   = $max_sirial;
              $srv_data[$k]["set_cd"]   = $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'];
              $srv_data[$k]["set_date"] = pg_escape_string($rcv_date);
            }
            // when first display
            if($srv_data[$k]["set_date"] == ""){
              $_query = sprintf("update %s set set_cd = '%s',set_date = '%s' where sirial = %s ",
                      $table_name,
                      $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                      pg_escape_string($rcv_date),
                      $logdata["sirial"]
              );
              $this->sql->query($_query);
              $srv_data[$k]["set_cd"]   = $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'];
              $srv_data[$k]["set_date"] = pg_escape_string($rcv_date);
            }else{
              $srv_data[$k]["set_cd"]   = $logdata["set_cd"];
              $srv_data[$k]["set_date"] = $logdata["set_date"];
            }

            $buff = $logdata["mail_log"];
            $buff = explode("\n",$logdata["mail_log"]);

            $srv_data[$k]["CK00"] = 0;  // Local Bounce:
            $srv_data[$k]["CK01"] = 0;  // Foreign Bounce:
            $srv_data[$k]["CK02"] = 0;  // WARNING:
            $srv_data[$k]["CK03"] = 0;  // Relaying denied:
            $srv_data[$k]["CK04"] = 0;  // Unrecognized warning:
            $srv_data[$k]["CK05"] = 0;  // Failed logins from these:
            $srv_data[$k]["CK06"] = 0;  // **Unmatched Entries**
            $srv_data[$k]["CK07"] = 0;  //    Unknown Entries:
            $srv_data[$k]["CK08"] = 0;  // Disk Space

            foreach($buff as $b){
              if(preg_match("/^\sLocal\sBounce:.*$/i",$b)){
                $srv_data[$k]["CK00"] = 1;
              }
              if(preg_match("/^\sForeign\sBounce:.*$/i",$b)){
                $srv_data[$k]["CK01"] = 1;
              }
              if(preg_match("/^\sWARNING:.*$/i",$b)){
                $srv_data[$k]["CK02"] = 1;
              }
              if(preg_match("/^\sRelaying\sdenied:.*$/i",$b)){
                $srv_data[$k]["CK03"] = 1;
              }
              if(preg_match("/^\sUnrecognized\swarning:.*$/i",$b)){
                $srv_data[$k]["CK04"] = 1;
              }
              if(preg_match("/^\sFailed\slogins\sfrom\sthese:.*$/i",$b)){
                $srv_data[$k]["CK05"] = 1;
              }
              if(preg_match("/^.*Unmatched\sEntries.*$/i",$b)){
                $srv_data[$k]["CK06"] = 1;
              }
              if(preg_match("/^.*Unknown\sEntries:.*$/i",$b)){
                $srv_data[$k]["CK07"] = 1;
              }
              if(preg_match("/^\s\/dev\/[sh]d[a-z][0-9][\s]+[0-9\.KMG]+[\s]+[0-9\.KMG]+[\s]+[0-9\.KMG]+[\s]+([0-9]+)\%.*/",$b,$mat)){
                if($mat[1] >= 50){
                  $srv_data[$k]["CK08"] = 1;
                }
              }
            }
            $srv_data[$k]["rcv_date"]  = $logdata["rcv_date"];
            $srv_data[$k]["memo_cd"]   = $logdata["memo_cd"];
            $srv_data[$k]["memo_date"] = $logdata["memo_date"];
            $old_key = $new_key;
          }
          return $this->fncArray2Xml($srv_data,"Records","sirial");
        case "C":
          $rcv_date = $formvars["reg_date_c"];
          $table_name = "logs_cron";
          $srv_data = array();
          $this->sql->query("select sirial,srv_name,subject,mail_log,rcv_date,memo_cd,memo_date from logs_cron where rcv_date like '$rcv_date%' order by srv_name,rcv_date ",
                           SQL_ALL,
                           SQL_ASSOC
                    );
          $srv_data = $this->sql->record;
          return $this->fncArray2Xml($srv_data,"Records","sirial");
        case "CF":
          $rcv_date    = $formvars["reg_date_c"];
          $search_word = $formvars["search_word"];
          $table_name = "logs_cron";
          $srv_data = array();
          $this->sql->query("select sirial,srv_name,subject,mail_log,rcv_date,memo_cd,memo_date from logs_cron where rcv_date like '$rcv_date%' and mail_log like '%$search_word%' order by srv_name,rcv_date ",
                           SQL_ALL,
                           SQL_ASSOC
                    );
          $srv_data = $this->sql->record;
          return $this->fncArray2Xml($srv_data,"Records","sirial");
        default :
          return FALSE;
      }
    }


    /**
     * get the daily logsbook entries
     */
    function getMailValue($sirial,$mode) {
      switch($mode){
        case "T":
          $table_name = "logs_tripwire";
          break;
        case "L":
          $table_name = "logs_logwatch";
          break;
        case "C":
          $table_name = "logs_cron";
          break;
        case "CF":
          $table_name = "logs_cron";
          break;
        default :
          return FALSE;
      }
      $this->sql->query("select mail_log from $table_name where sirial = $sirial ",
                       SQL_INIT,
                       SQL_ASSOC
                );
      return $this->sql->record;
    }


    /**
     * get the daily logsbook entries
     */
    function getMemoValue($sirial,$mode) {
      switch($mode){
        case "T":
          $table_name = "logs_tripwire";
          break;
        case "L":
          $table_name = "logs_logwatch";
          break;
        case "C":
          $table_name = "logs_cron";
          break;
        case "CF":
          $table_name = "logs_cron";
          break;
        default :
          return FALSE;
      }
      $this->sql->query("select sirial,srv_name,free_memo from $table_name where sirial = $sirial ",
                       SQL_INIT,
                       SQL_ASSOC
                );
      return $this->sql->record;
    }


     /**
     * display the tripwirebook for daily logs
     *
     * @param array $data the tripwirebook data
     */
    function displayDailyTripwireBook($xml = "") {
      $_SESSION[SERVER_MANAGER_SES_NAME]["reg_date_t"] = htmlspecialchars($_POST["reg_date_t"]);
      $header  = "";
      $header .= "<status>".htmlspecialchars($_POST["status"])."</status>\n";
      $this->fncDisplayWithXml($xml,'daily_tripwirebook.php',$header);
    }


     /**
     * display the logwatchbook for daily logs
     *
     * @param array $data the logwatchbook data
     */
    function displayDailyLogwatchBook($xml = "") {
      $_SESSION[SERVER_MANAGER_SES_NAME]["reg_date_l"] = htmlspecialchars($_POST["reg_date_l"]);
      $header  = "";
      $header .= "<status>".htmlspecialchars($_POST["status"])."</status>\n";
      $this->fncDisplayWithXml($xml,'daily_logwatchbook.php',$header);
    }


     /**
     * display the cronbook for daily logs
     *
     * @param array $data the cronbook data
     */
    function displayDailyCronBook($xml = "") {
      $_SESSION[SERVER_MANAGER_SES_NAME]["reg_date_c"] = htmlspecialchars($_POST["reg_date_c"]);
      $_SESSION[SERVER_MANAGER_SES_NAME]["search_word"] = htmlspecialchars($_POST["search_word"]);
      $header  = "";
      $header .= "<status>".htmlspecialchars($_POST["status"])."</status>\n";
      $this->fncDisplayWithXml($xml,'daily_cronbook.php',$header);
    }


    /**
     * get the server living confirmation log 
     */
    function getDailyLivingMail($formvars = array()) {
      $rcv_date   = $formvars["rcv_date"];
      $query = "select sirial,srv_cd,srv_name,subject,rcv_date from logs_hourly where rcv_date like '$rcv_date' order by rcv_date desc,srv_cd ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"Records","srv_cd");
    }


    /**
     * display the server living confirmation log 
     */
    function displayLivingMailBook($xml = "") {
      $_SESSION[SERVER_MANAGER_SES_NAME]["rcv_date"] = htmlspecialchars($_POST["rcv_date"]);
      $header  = "";
      $header .= "<status>".htmlspecialchars($_POST["status"])."</status>\n";
      $this->fncDisplayWithXml($xml,'living_mail.php',$header);
    }


     /**
     * display the serverbook for install logs
     *
     * @param array $data the serverbook data
     */
    function displayInstallServerBook($xml = "") {
      $this->fncDisplayWithXml($xml,'install_serverbook.php');
    }


     /**
     * get the server install logs 
     */
    function getServerInstallLogs($formvars = array()) {
      $xml = "";
      $buff[0] = $formvars;
      $xml .= $this->fncArray2Xml($buff,"Get");
      $srv_cd = $formvars["srv_cd"];
      $query = "select memo_cd,srv_cd,title,reg_date,usr_cd,lock_flag from fil_server_memo where srv_cd = '$srv_cd' order by memo_cd desc";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $xml .= $this->fncArray2Xml($this->sql->record,"Records","srv_cd");
      return $xml;
    }


     /**
     * display the server install logs 
     *
     * @param array $data the serverbook data
     */
    function displayInstallLogs($xml = "") {
      $this->fncDisplayWithXml($xml,'install_server_logs.php');
    }


    /**
     * unlock the serverlog entry
     */
    function lockServerInstallLogEntryAF($srv_cd) {
      $_query = sprintf("update fil_server_memo set lock_flag = null where srv_cd = '%s' ", pg_escape_string($srv_cd));
      return $this->sql->query($_query);
    }


    /**
     * lock the serverlog entry
     */
    function lockServerInstallLogEntry($memo_cd) {
      $_query = sprintf("update fil_server_memo set lock_flag = 't' where memo_cd = '%s' ",pg_escape_string($memo_cd));
      return $this->sql->query($_query);
    }


     /**
     * display the install log adding form
     *
     */
    function displayInstallLogAddForm($xml = "") {
      $this->fncDisplayWithXml($xml,'add_server_install_log_form.php');
    }


    /**
     * trim a server install logs form data
     *
     * @param array $formvars the form variables
     */
    function mungeServerInstallFormData(&$formvars) {
      // trim off excess whitespace
      $formvars['title']  = trim($formvars['title']);
      $formvars['memo']   = trim($formvars['memo']);
    }


    /**
     * test a server install logs form data
     *
     * @param array $formvars the form variables
     */
    function isValidInstallServerLogForm($formvars) {
      if(strlen($formvars['title']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'title';
        return false; 
      }
      if(strlen($formvars['memo']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'memo';
        return false; 
      }
      // form passed validation
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      return true;
    }


    /**
     * get a new max memo_cd
     *
     * @param array $formvars the form variables
     */
    function getMaxMemoCD() {
      // select max memo_cd
      $query = "select max(memo_cd) + 1 as max_memo_cd from fil_server_memo";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      if($this->sql->record[0]['max_memo_cd'] == ''){
        $this->sql->record[0]['max_memo_cd'] = 1;
        return $this->sql->record;
      }else{
        return $this->sql->record;
      }
    }


    /**
     * add a new server install log entry
     *
     * @param array $formvars the form variables
     */
    function addServerInstallLogEntry($formvars, $data = array()) {
        $max_memo_cd = $data[0]['max_memo_cd'];
        $_query = sprintf("insert into fil_server_memo values('%s','%s','%s',NOW(),'%s','%s')",
                $max_memo_cd,
                $formvars["srv_cd"],
                pg_escape_string($formvars['title']),
                pg_escape_string($formvars['memo']),
                $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd']
        );
        return $this->sql->query($_query);
    }


    /**
     * get one of the server install log 
     */
    function getInstallLogEntries($formvars = array()) {
      $xml = "";
      $buff[0] = $formvars;
      $xml .= $this->fncArray2Xml($buff,"Entry");
      $memo_cd = $formvars["memo_cd"];
      $query = "select * from fil_server_memo where memo_cd = '$memo_cd'";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $xml .= $this->fncArray2Xml($this->sql->record,"Records","memo_cd");
      return $xml;
    }


    /**
     * display one of the server install log 
     *
     * @param array $data the serverbook data
     */
    function displayInstallLogEditForm($xml = "") {
      $this->fncDisplayWithXml($xml,'edit_server_install_log_form.php');
    }


    /**
     * edit the server install log entry
     *
     * @param array $formvars the form variables
     */
    function confirmServerInstallLogEntry($formvars) {
      $_query = sprintf("update fil_server_memo set title         = '%s',
                                                    memo          = '%s',
                                                    reg_date      = NOW(),
                                                    usr_cd        = '%s'
                          where memo_cd = '%s'",
                          pg_escape_string($formvars['title']),
                          pg_escape_string($formvars['memo']),
                          $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                          pg_escape_string($formvars['memo_cd'])
        );
        return $this->sql->query($_query);
    }


    /**
     * delete the server install log
     *
     * @param array $formvars the form variables
     */
    function deleteServerInstallLogEntry($formvars = array()) {
      $memo_cd = $formvars["memo_cd"];
      $_query = sprintf("delete from fil_server_memo where memo_cd = '$memo_cd'");
      return $this->sql->query($_query);
    }


    /**
     * get the routerbook entries
     */
    function getRouterEntries($formvars = array()) {
      $userclass = $_SESSION[SERVER_MANAGER_SES_NAME]["user_class"];
      $disp_flag = $formvars["flg"];
      $xml = "";
      $buff[0] = $formvars;
      $xml .= $this->fncArray2Xml($buff,"Entry");
      if($disp_flag == 'dsp'){
        $query = "select * from mst_server where router_flag = 't' order by srv_name";
        $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      } else {
        $query = "select * from mst_server where disp_flag = 't' and router_flag = 't' order by srv_name ";
        $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      }
      $xml .= $this->fncArray2Xml($this->sql->record,"Records","srv_cd");
      return $xml;
    }


    /**
     * display the routerbook entries
     */
    function displayInstallRouterBook($xml = "") {
      $this->fncDisplayWithXml($xml,'install_routerbook.php');
    }


     /**
     * get the router install logs 
     */
    function getRouterInstallLogs($formvars = array()) {
      $xml = "";
      $buff[0] = $formvars;
      $xml .= $this->fncArray2Xml($buff,"Get");
      $srv_cd = $formvars["srv_cd"];
      $query = "select * from fil_router_log where srv_cd = '$srv_cd' order by reg_date desc";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $xml .= $this->fncArray2Xml($this->sql->record,"Records","srv_cd");
      return $xml;
    }


     /**
     * display the router install logs 
     *
     * @param array $data the serverbook data
     */
    function displayRouterInstallLogs($xml = "") {
      $this->fncDisplayWithXml($xml,'install_router_logs.php');
    }


    /**
     * fix up form data if necessary
     *
     * @param array $formvars the form variables
     */
    function mungeRouterInstallFormData(&$formvars) {
      // trim off excess whitespace
      $formvars['memo']   = trim($formvars['memo']);
    }


    /**
     * test if form information is valid
     *
     * @param array $formvars the form variables
     */
    function isValidInstallRouterLogForm($formvars) {
      if(strlen($formvars['memo']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'you must input memo field.';
        return false; 
      }
      // form passed validation
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      return true;
    }


    /**
     * get a new max memo_cd
     *
     * @param array $formvars the form variables
     */
    function getRouterMaxMemoCD() {
      // select max serial
      $query = "select coalesce(max(serial)+1,0) as max_serial from fil_router_log ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      if($this->sql->record[0]['max_serial'] == ''){
        $this->sql->record[0]['max_serial'] = 1;
        return $this->sql->record;
      }else{
        return $this->sql->record;
      }
    }


    /**
     * add a router install log entry
     *
     * @param array $formvars the form variables
     */
    function addRouterInstallLogEntry($formvars,$files, $data = array()) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
        $this->sql->query("begin");
        $max_serial = $data[0]['max_serial'];
        $fname = $files["attache_file"]["name"];
        $ftype = $files["attache_file"]["type"];
        $fsize = $files["attache_file"]["size"];

        $conn_id = @ftp_connect(FTP_SERVER);
        if($conn_id != false && $_SESSION[SERVER_MANAGER_SES_NAME]["error"] == null){
          // Quote string with slashes
          $fname = addslashes($fname);
          $remote_file = "r".$max_serial.".dat";
          // It logs it in specifying the user-name and the password.
          $login_result = @ftp_login($conn_id, FTP_USER_NAME, FTP_USER_PASS);
          // Whether it was possible to connect it is confirmed. 
          if ((!$conn_id) || (!$login_result)) {
            $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "It failed in the connection to the file server.";
            $this->sql->query("rollbak");
            return false;
          }

          // A passive mode is on.
          @ftp_pasv($conn_id, true);
          // Change in remote directory.
          if (!@ftp_chdir($conn_id, REMOTE_DIR)) {
            $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "It failed in the connection to the file server.";
            $this->sql->query("rollbak");
            return false;
          }

          $tmp_name = $files["attache_file"]["tmp_name"].".gz";
          if(!gzip($files["attache_file"]["tmp_name"],$tmp_name,9)){
            $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "The problem occurred when the file was compressed.";
            $this->sql->query("rollbak");
            return false;
          }
          // It up-loads $remote_file by the FTP.
          if (!@ftp_put($conn_id, $remote_file, $tmp_name, FTP_BINARY)) {
            $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "The problem occurred when the file was up-loaded.";
            $this->sql->query("rollbak");
            return false;
          }
          @unlink($tmp_name);

          // The connection and the file handler are shut.
          @ftp_close($conn_id);
        }


        $_query = sprintf("insert into fil_router_log values('%s','%s','%s','%s','%s','%s',NOW(),'%s','f')",
                $max_serial,
                $formvars["srv_cd"],
                pg_escape_string($formvars['memo']),
                pg_escape_string($fname),
                pg_escape_string($ftype),
                pg_escape_string($fsize),
                $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd']
        );
        $res = $this->sql->query($_query);

        if($res == false){
          $this->sql->query("rollbak");
          return false;
        }else{
          $this->sql->query("commit");
          return true;
        }
    }


    /**
     * get the router install log
     *
     * @param array $formvars the form variables
     */
    function getOneRouterInstallLog($formvars = array()) {
      $_SESSION[SERVER_MANAGER_SES_NAME]["router"]["mode"] = "edit";
      $xml = "";
      $buff[0] = $formvars;
      $xml .= $this->fncArray2Xml($buff,"Post");
      $serial = $formvars["serial"];
      $query = "select * from fil_router_log where serial = '$serial'";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $xml .= $this->fncArray2Xml($this->sql->record,"Data","serial");
      return $xml;
    }


    /**
     * get the router install log file
     */
    function getRouterFile($serial) {
      $query = "select fname,ftype,fsize from fil_router_log where serial = '$serial' ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      return $this->sql->record;
    }


    /**
     * edit the router install log
     *
     * @param array $formvars the form variables
     */
    function confirmRouterInstallLogEntry($formvars,$files) {
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      $this->sql->query("begin");

      if($_SESSION[SERVER_MANAGER_SES_NAME]["router"]["attache"] == true){
        if($files["attache_file"]["size"] > 200 * 1024 * 1024){
          $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "The size of the file is up to 200MB.";
          return;
        }
        $fname = $files["attache_file"]["name"];
        $ftype = $files["attache_file"]["type"];
        $fsize = $files["attache_file"]["size"];

        $conn_id = @ftp_connect(FTP_SERVER);
        if($conn_id != false && $msg == ""){
          // Quote string with slashes.
          $fname = addslashes($fname);
          $remote_file = "r".$formvars["serial"].".dat";
          // It logs it in specifying the user-name and the password.
          $login_result = @ftp_login($conn_id, FTP_USER_NAME, FTP_USER_PASS);
          // Whether it was possible to connect it is confirmed.
          if ((!$conn_id) || (!$login_result)) {
            $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "It failed in the connection to the file server.";
            $this->sql->query("rollbak");
            return false;
          }

          // A passive mode is on. 
          @ftp_pasv($conn_id, true);
          // Change in remote directory.
          if (!@ftp_chdir($conn_id, REMOTE_DIR)) {
            $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "It failed in the connection to the file server.";
            $this->sql->query("rollbak");
            return false;
          }

          $tmp_name = $files["attache_file"]["tmp_name"].".gz";
          if(!gzip($files["attache_file"]["tmp_name"],$tmp_name,9)){
            $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "The problem occurred when the file was compressed.";
            $this->sql->query("rollbak");
            return false;
          }
          // It up-loads $remote_file by the FTP.
          if (!@ftp_put($conn_id, $remote_file, $tmp_name, FTP_BINARY)) {
            $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "The problem occurred when the file was up-loaded.";
            $this->sql->query("rollbak");
            return false;
          }
          @unlink($tmp_name);

          // The connection and the file handler are shut.
          @ftp_close($conn_id);
        }
      }

      if(is_uploaded_file($files["attache_file"]["tmp_name"])){
        $_query = sprintf("update fil_router_log set memo='%s',fname='%s',ftype='%s',fsize='%s',reg_date='NOW()',usr_cd='%s' where serial = '%s' and lock_flag = 'f'",
                    pg_escape_string($formvars['memo']),pg_escape_string($fname),pg_escape_string($ftype),
                    pg_escape_string($fsize),$_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],pg_escape_string($formvars['serial'])
                  );
      }else{
        $_query = sprintf("update fil_router_log set memo='%s',reg_date='NOW()',usr_cd='%s' where serial = '%s' and lock_flag = 'f'",
                    pg_escape_string($formvars['memo']),$_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],pg_escape_string($formvars['serial'])
                  );
      }
      $res = $this->sql->query($_query);

      if($res){
        $this->sql->query("commit");
        return true;
      }else{
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "update error.";
        $this->sql->query("rollbak");
        return false;
      }
    }


    /**
     * delete the router install log
     *
     * @param array $formvars the form variables
     */
    function deleteRouterInstallLogEntry($formvars = array()) {
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      $this->sql->query("begin");
      $serial = $formvars["serial"];

      $conn_id = @ftp_connect(FTP_SERVER);
      if($conn_id != false && $_SESSION[SERVER_MANAGER_SES_NAME]["error"] == null){
        // Quote string with slashes.
        $fname = addslashes($fname);
        $remote_file = "r".$serial.".dat";
        // It logs it in specifying the user-name and the password.
        $login_result = @ftp_login($conn_id, FTP_USER_NAME, FTP_USER_PASS);
        // Whether it was possible to connect it is confirmed.
        if ((!$conn_id) || (!$login_result)) {
          $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "It failed in the connection to the file server.";
          $this->sql->query("rollbak");
          return false;
        }

        // A passive mode is on.
        @ftp_pasv($conn_id, true);
        // Change in remote directory.
        if (!@ftp_chdir($conn_id, REMOTE_DIR)) {
          $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "It failed in the connection to the file server.";
          $this->sql->query("rollbak");
          return false;
        }

        // It remove $remote_file by the FTP.
        if (!@ftp_delete($conn_id, $remote_file)) {
          $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "The problem occurred when the file was deleted.";
          $this->sql->query("rollbak");
          return false;
        }
        // The connection and the file handler are shut.
        @ftp_close($conn_id);
      }else{
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "It failed in the connection to the file server.";
        $this->sql->query("rollbak");
        return false;
      }

      $_query = sprintf("delete from fil_router_log where serial = '$serial' and lock_flag = 'f' ");
      $res = $this->sql->query($_query);
      if($res){
        $this->sql->query("commit");
        return true;
      }else{
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = "delete error.";
        $this->sql->query("rollbak");
        return false;
      }
    }


    /**
     * unlock the routerlog entry
     */
    function lockRouterInstallLogEntryAF($srv_cd) {
      $_query = sprintf("update fil_router_log set lock_flag = 'f' where srv_cd = '%s' ", pg_escape_string($srv_cd));
      return $this->sql->query($_query);
    }


    /**
     * lock the routerlog entry
     */
    function lockRouterInstallLogEntry($serial) {
      $_query = sprintf("update fil_router_log set lock_flag = 't' where serial = '%s' ",pg_escape_string($serial));
      return $this->sql->query($_query);
    }


    /**
     * get the serverbook entry
     */
    function getSrvName() {
      $query = "select srv_cd,srv_name from mst_server where disp_flag = 't' and router_flag = 'f' order by srv_name ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"SrvSel","srv_cd");
    }


    /**
     * display Set Key Word For Search Install Logs
     *
     */
    function setSearchForInstallLogs($xml = "") {
      $this->fncDisplayWithXml($xml,'search_install_log_form.php');
    }


    /**
     * fix up form data if necessary
     *
     * @param array $formvars the form variables
     */
    function mungeSearchInstallLogsFormData(&$formvars) {
      // trim off excess whitespace
      $formvars['key_word']   = trim($formvars['key_word']);
      $formvars['key_memo']   = trim($formvars['key_memo']);
    }


    /**
     * test if form information is valid
     *
     * @param array $formvars the form variables
     */
    function isValidSearchInstallLogsTitle($formvars) {
      if(strlen($formvars['key_word']) < 1) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'key_word';
        return false; 
      }
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      return true;
    }


     /**
     * get the install log lists 
     */
    function getSearchInstallLogs($formvars) {
      $key_word = $formvars["key_word"];
      $query  = "select a.memo_cd,a.srv_cd,b.srv_name,a.title,a.reg_date,a.usr_cd,b.os ";
      $query .= "from (select memo_cd,srv_cd,title,reg_date,usr_cd from fil_server_memo where title LIKE '%$key_word%' order by memo_cd desc )as a ";
      $query .= "left outer join mst_server as b on a.srv_cd = b.srv_cd ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"Records","memo_cd");
    }


    /**
     * display Search Install Log Lists
     */
    function displaySearchForInstallLogLists($xml = "") {
      $this->fncDisplayWithXml($xml,'search_install_log_list.php');
    }


    /**
     * test if form information is valid
     *
     * @param array $formvars the form variables
     */
    function isValidSearchInstallLogsMemo($formvars) {
      if(strlen($formvars['key_memo']) < 1) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'key_memo';
        return false; 
      }
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      return true;
    }


     /**
     * get the install log memo lists 
     */
    function getSearchInstallMemos($formvars) {
      // assign the form vars
      $key_memo = $formvars["key_memo"];
      $query  = "select a.memo_cd,a.srv_cd,b.srv_name,a.title,a.reg_date,a.usr_cd,b.os ";
      $query .= "from (select memo_cd,srv_cd,title,reg_date,usr_cd from fil_server_memo where memo LIKE '%$key_memo%' order by memo_cd desc )as a ";
      $query .= "left outer join mst_server as b on a.srv_cd = b.srv_cd ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"Records","memo_cd");
    }


    /**
     * test if form information is valid
     *
     * @param array $formvars the form variables
     */
    function mungeSearchServerLogsFormData(&$formvars) {
      // trim off excess whitespace
      $formvars['o_key_word'] = trim($formvars['o_key_word']);
      $formvars['n_key_word'] = trim($formvars['n_key_word']);
    }


    /**
     * test if form information is valid
     *
     * @param array $formvars the form variables
     */
    function isValidSearchServerLogsNew($formvars) {
      if(strlen($formvars['n_key_word']) < 1) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'n_key_word';
        return false; 
      }
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      return true;
    }


     /**
     * get the old server log lists 
     */
    function getSearchServerLogsNew($formvars) {
      $key_word = $formvars["n_key_word"];
      $sea_opt  = $formvars["n_sea_opt"];
      $srv_cd   = $formvars["srv_cd"];
      $query  = "select kbn,sirial,srv_name,rcv_date,set_cd,subject from ( ";
      switch($sea_opt){
        case 1: 
          $query .= "  select 1 as kbn,sirial,srv_name,rcv_date,set_cd,subject,mail_log,free_memo from logs_logwatch ";
          break;
        case 2: 
          $query .= "  select 2 as kbn,sirial,srv_name,rcv_date,set_cd,subject,mail_log,free_memo from logs_tripwire ";
          break;
        case 3: 
          $query .= "  select 3 as kbn,sirial,srv_name,rcv_date,set_cd,subject,mail_log,free_memo from logs_cron ";
          break;
        default : 
          $query .= "  select 1 as kbn,sirial,srv_name,rcv_date,set_cd,subject,mail_log,free_memo from logs_logwatch ";
          $query .= "  union ";
          $query .= "  select 2 as kbn,sirial,srv_name,rcv_date,set_cd,subject,mail_log,free_memo from logs_tripwire ";
          $query .= "  union ";
          $query .= "  select 3 as kbn,sirial,srv_name,rcv_date,set_cd,subject,mail_log,free_memo from logs_cron ";
          break;
      }
      $query .= ")as a ";
      $query .= "where mail_log LIKE '%$key_word%' or free_memo LIKE '%$key_word%' ";
      if($srv_cd != ""){
        $query .= "and srv_name = (select srv_name from mst_server where srv_cd = $srv_cd) ";
      }
      $query .= "order by kbn,srv_name,rcv_date desc ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff = $this->sql->record;
      return $this->fncArray2Xml($buff,"Records","kbn");
    }


    /**
     * display Search Server Log Lists
     */
    function displaySearchForServerLogLists($mode,$xml = "") {
        $this->fncDisplayWithXml($xml,'search_server_new_list.php');
    }


    /**
     * display one of the server install log 
     *
     * @param array $data the serverbook data
     */
    function displaySearchInstallLogEditForm($xml = "") {
      $this->fncDisplayWithXml($xml,'search_server_install_log_form.php');
    }


    /**
     * get one of the server install log 
     */
    function getNewServerLogEntries($formvars = array()) {
      $xml = "";
      $buff[0] = $formvars;
      $xml .= $this->fncArray2Xml($buff,"Entry");
      $kbn    = $formvars["kbn"];
      $sirial = $formvars["sirial"];
      switch($kbn){
        case "1" :
          $query = "select * from logs_logwatch where sirial = '$sirial'";
          break;
        case "2" :
          $query = "select * from logs_tripwire where sirial = '$sirial'";
          break;
        case "3" :
          $query = "select * from logs_cron where sirial = '$sirial'";
          break;
      }
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $xml .= $this->fncArray2Xml($this->sql->record,"Records","sirial");
      return $xml;
    }


    /**
     * display one of the server install log 
     *
     * @param array $data the serverbook data
     */
    function displaySearchServerLogEditForm($mode,$xml = "") {
        $this->fncDisplayWithXml($xml,'search_new_server_log_form.php');
    }


     /**
     * get the account 
     */
    function getAccountAll($formvars = array()) {
      $query  = "";
      $query .= "select a.usr_cd,a.password,a.class_cd,a.usr_name,a.username,a.mail_addr,a.last_cd,a.last_date,b.class_name,b.class_exp ";
      $query .= "from (select usr_cd,password,class_cd,usr_name,username,mail_addr,last_cd,last_date from mst_usr order by usr_cd )as a ";
      $query .= "left outer join tbl_class as b on b.class_cd = a.class_cd ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"Records","usr_cd");
    }


     /**
     * display the account
     *
     * @param array $data the account data
     */
    function displayAccountAll($xml = "") {
      $this->fncDisplayWithXml($xml,'account_all.php');
    }


     /**
     * get the new user class 
     *
     */
    function getUserClass() {
      $query = "select * from tbl_class order by class_cd ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"Records","class_cd");
    }


     /**
     * display the add account form
     *
     */
    function displayAccountAddForm($xml = "") {
      $this->fncDisplayWithXml($xml,'add_account.php');
    }


    /**
     * fix up form data if necessary
     *
     * @param array $formvars the form variables
     */
    function mungeAccountFormData(&$formvars) {
      // trim off excess whitespace
      $formvars['password']   = trim($formvars['password']);
      $formvars['class_cd']   = trim($formvars['class_cd']);
      $formvars['username']   = trim($formvars['username']);
      $formvars['usr_name']   = trim($formvars['usr_name']);
      $formvars['mail_addr']  = trim($formvars['mail_addr']);
    }


    /**
     * test if form information is valid
     *
     * @param array $formvars the form variables
     */
    function isValidAccountForm($formvars) {
      if(strlen($formvars['password']) < 8) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'password';
        return false; 
      }
      if(strlen($formvars['class_cd']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'class_cd';
        return false; 
      }
      if(strlen($formvars['username']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'username';
        return false; 
      }
      if(strlen($formvars['usr_name']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'usr_name';
        return false; 
      }
      if(strlen($formvars['mail_addr']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'mail_addr';
        return false; 
      }
      // select username
      $username = pg_escape_string($formvars['username']);
      $query = "select username from mst_usr where username = '$username'";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      if($this->sql->record) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'doubled_username';
        return false; 
      }
      // select mail address
      $mail_addr = pg_escape_string($formvars['mail_addr']);
      $query = "select mail_addr from mst_usr where mail_addr = '$mail_addr'";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      if($this->sql->record) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'doubled_mail_addr';
        return false; 
      }

      // form passed validation
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      return true;
    }


    /**
     * get a new max usr_cd
     *
     * @param array $formvars the form variables
     */
    function getMaxAccount() {
      // select max usr_cd
      $query = "select max(usr_cd) + 1 as max_usr_cd from mst_usr";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      if($this->sql->record[0]['max_usr_cd'] == ''){
        $this->sql->record[0]['max_usr_cd'] = 1;
        return $this->sql->record;
      }else{
        return $this->sql->record;
      }
    }


    /**
     * add a new account
     *
     * @param array $formvars the form variables
     */
    function addAccountEntry($formvars, $data = array()) {
      $max_usr_cd = $data[0]['max_usr_cd'];
      $_query = sprintf("insert into mst_usr values('%s','%s','%s','%s','%s','%s','%s','%s')",
              $max_usr_cd,
              pg_escape_string(md5($formvars['password'])),
              pg_escape_string($formvars['class_cd']),
              pg_escape_string($formvars['usr_name']),
              pg_escape_string($formvars['mail_addr']),
              $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
              NOW,
              pg_escape_string($formvars['username'])
      );
      return $this->sql->query($_query);
    }


    /**
     * get a account entry
     *
     * @param array $formvars the form variables
     */
    function getUserClassS($formvars) {
      $usr_cd = $formvars["usr_cd"];
      $query  = "select a.*,b.sel from tbl_class as a ";
      $query .= "left outer join (select class_cd,1 as sel from mst_usr where usr_cd = $usr_cd) as b on a.class_cd = b.class_cd ";
      $query .= "order by a.class_cd ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"Cls","class_cd");
    }


    /**
     * get one of the account
     */
    function getOneAccountEntries($formvars = array()) {
      $usrcd = $formvars["usr_cd"];
      $query = "select * from mst_usr where usr_cd = $usrcd ";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      $buff =  $this->sql->record;
      return $this->fncArray2Xml($buff,"Records","usr_cd");
    }


    /**
     * display one of the account 
     *
     * @param array $data the account data
     */
    function displayAccountEditForm($xml = "") {
      $this->fncDisplayWithXml($xml,'edit_account.php');
    }


    /**
     * test if form information is valid
     *
     * @param array $formvars the form variables
     */
    function isValidAccountEditForm($formvars) {
      if(strlen($formvars['password']) < 8) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'password';
        return false; 
      }
      if(strlen($formvars['class_cd']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'class_cd';
        return false; 
      }
      if(strlen($formvars['username']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'username';
        return false; 
      }
      if(strlen($formvars['usr_name']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'usr_name';
        return false; 
      }
      if(strlen($formvars['mail_addr']) == 0) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'mail_addr';
        return false; 
      }
      // select username
      $usr_cd = $formvars['usr_cd'];
      $username = pg_escape_string($formvars['username']);
      $query = "select username from mst_usr where username = '$username' and usr_cd != '$usr_cd'";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      if($this->sql->record) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'doubled_username';
        return false; 
      }
      // select mail address
      $usr_cd = $formvars['usr_cd'];
      $mail_addr = pg_escape_string($formvars['mail_addr']);
      $query = "select mail_addr from mst_usr where mail_addr = '$mail_addr' and usr_cd != '$usr_cd'";
      $this->sql->query($query,SQL_ALL,SQL_ASSOC);
      if($this->sql->record) {
        $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = 'doubled_mail_addr';
        return false; 
      }

      // form passed validation
      $_SESSION[SERVER_MANAGER_SES_NAME]["error"] = null;
      return true;
    }


    /**
     * edit the account entry
     *
     * @param array $formvars the form variables
     */
    function editAccountEntry($formvars) {
      $_query = sprintf("update mst_usr set password         = '%s',
                                            class_cd         = '%s',
                                            username         = '%s',
                                            usr_name         = '%s',
                                            mail_addr        = '%s',
                                            last_cd          = '%s',
                                            last_date        = '%s'
                          where usr_cd = '%s'",
                          pg_escape_string(md5($formvars['password'])),
                          pg_escape_string($formvars['class_cd']),
                          pg_escape_string($formvars['username']),
                          pg_escape_string($formvars['usr_name']),
                          pg_escape_string($formvars['mail_addr']),
                          $_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'],
                          NOW,
                          pg_escape_string($formvars['usr_cd'])
      );
      return $this->sql->query($_query);
    }


    /**
     * delete the account
     *
     * @param array $formvars the form variables
     */
    function deleteAccount($formvars = array()) {
      $usr_cd = $formvars["usr_cd"];
      $_query = sprintf("delete from mst_usr where usr_cd = '$usr_cd'");
      return $this->sql->query($_query);
    }



     /**
     * get the user install log 
     */
    function isUserInstallLog($formvars = array()) {
        $usr_cd = $formvars["usr_cd"];
        $query = "select count(*) as count from fil_router_log where usr_cd = '$usr_cd' ";
        $query .= "union select count(*) as count from fil_server_memo where usr_cd = '$usr_cd' ";
        $query .= "union select count(*) as count from logs_cron where set_cd = '$usr_cd' ";
        $query .= "union select count(*) as count from logs_logwatch where set_cd = '$usr_cd' ";
        $query .= "union select count(*) as count from logs_tripwire where set_cd = '$usr_cd' ";
        $query .= "union select count(*) as count from mst_server where usr_cd = '$usr_cd' ";
        $query .= "union select count(*) as count from mst_server_usr where usr_cd = '$usr_cd' ";
        $this->sql->query($query,SQL_ALL,SQL_ASSOC);
        if(($this->sql->record[0]["count"] == 0 )
            && ($this->sql->record[1]["count"] == 0 )
            && ($this->sql->record[2]["count"] == 0 )
            && ($this->sql->record[3]["count"] == 0 )
            && ($this->sql->record[4]["count"] == 0 )
            && ($this->sql->record[5]["count"] == 0 )
            && ($this->sql->record[6]["count"] == 0 )){
           return TRUE;
        } else {
           return FALSE;
        }
    }


    /**
    * display the invalid delete user
    */
    function displayDeleteUserFailed($xml = "") {
      $this->fncDisplayWithXml($xml,'invalid_delete_user_form.php');
    }


    /**
     * add a new server daily log entry
     *
     * @param array $rcv_data the mail received data
     */
    function addServerDailyLogReceived($rcv_data, $mode) {
        switch($mode){
          case "T": // TripWire
            $ins_table = "logs_tripwire";
            break;
          case "L": // LogWatch
            $ins_table = "logs_logwatch";
            break;
          case "C": // Cron
            $ins_table = "logs_cron";
            break;
          default :
            return FALSE;
        }

        // select max serial
        $this->sql->query("select coalesce(max(sirial)+1,1) as max_sirial from $ins_table",SQL_INIT,SQL_ASSOC);
        $data =  $this->sql->record;

        $max_sirial = $data['max_sirial'];

        // sirial,subject,mail_log,free_memo,rcv_date
        $_query = sprintf("insert into %s values('%s','%s','%s','%s','%s',NOW())",
                $ins_table,
                $max_sirial,
                pg_escape_string($rcv_data["srv_name"]),
                pg_escape_string($rcv_data["subject"]),
                pg_escape_string($rcv_data["mail_log"]),
                pg_escape_string($rcv_data['free_memo'])
        );
        return $this->sql->query($_query);
    }


    /**
     * add a new server daily log entry
     *
     * @param array $rcv_data the mail received data
     */
    function addServerLivingLogReceived($rcv_data) {
        $_query = sprintf("insert into logs_hourly values('%s','%s','%s','%s',NOW(),'%s')",
           //$max_sirial,
           0,
           pg_escape_string($rcv_data["srv_cd"]),
           pg_escape_string($rcv_data["srv_name"]),
           pg_escape_string($rcv_data["subject"]),
           pg_escape_string($rcv_data["mbody"])
        );
        return $this->sql->query($_query);
    }


    /**
     * send to daily LogWatch report
     *
     * @param array $rcv_data the mail received data
     */
    function makeLogWatchReport($rcv_date) {
      $srv_data = array();
      $res = $this->sql->query("select srv_cd,srv_name,eth0_ipaddr from mst_server where wantlogcheck = 't' and router_flag = 'f' order by srv_name ",
                       SQL_ALL,
                       SQL_ASSOC
                );
      if($res === FALSE){
        return FALSE;
      }
      $srv_data = $this->sql->record;
      $offset = 0;
      $new_key = "";
      $old_key = $new_key;
      foreach($srv_data as $k=>$v){
        preg_match("/^([^\(]*[\.jp|\.com]).*$/",$v["srv_name"],$matchs);
        $new_key = $matchs[1];
        if($new_key == $old_key){
          $offset++;
        }else{
          $offset = 0;
        }
        $logdata = null;
        $res = $this->sql->query(
                      "select sirial,subject,mail_log,rcv_date,set_cd,set_date,memo_cd,memo_date from logs_logwatch where rcv_date like '$rcv_date%' and srv_name = '".$matchs[1]."' order by sirial offset $offset limit 1 ",
                       SQL_INIT,
                       SQL_ASSOC
                );
        if($res === FALSE){
          return FALSE;
        }
        $logdata =  $this->sql->record;
        $srv_data[$k]["sirial"]    = $logdata["sirial"];

        $buff = $logdata["mail_log"];
        $buff = explode("\n",$logdata["mail_log"]);

        $srv_data[$k]["CK00"] = 0;  // Local Bounce:
        $srv_data[$k]["CK01"] = 0;  // Foreign Bounce:
        $srv_data[$k]["CK02"] = 0;  // WARNING:
        $srv_data[$k]["CK03"] = 0;  // Relaying denied:
        $srv_data[$k]["CK04"] = 0;  // Unrecognized warning:
        $srv_data[$k]["CK05"] = 0;  // Failed logins from these:
        $srv_data[$k]["CK06"] = 0;  // **Unmatched Entries**
        $srv_data[$k]["CK07"] = 0;  //    Unknown Entries:
        $srv_data[$k]["CK08"] = 0;  // Disk Space

        foreach($buff as $b){
          if(preg_match("/^\sLocal\sBounce:.*$/i",$b)){
            $srv_data[$k]["CK00"] = 1;
          }
          if(preg_match("/^\sForeign\sBounce:.*$/i",$b)){
            $srv_data[$k]["CK01"] = 1;
          }
          if(preg_match("/^\sWARNING:.*$/i",$b)){
            $srv_data[$k]["CK02"] = 1;
          }
          if(preg_match("/^\sRelaying\sdenied:.*$/i",$b)){
            $srv_data[$k]["CK03"] = 1;
          }
          if(preg_match("/^\sUnrecognized\swarning:.*$/i",$b)){
            $srv_data[$k]["CK04"] = 1;
          }
          if(preg_match("/^\sFailed\slogins\sfrom\sthese:.*$/i",$b)){
            $srv_data[$k]["CK05"] = 1;
          }
          if(preg_match("/^.*Unmatched\sEntries.*$/i",$b)){
            $srv_data[$k]["CK06"] = 1;
          }
          if(preg_match("/^.*Unknown\sEntries:.*$/i",$b)){
            $srv_data[$k]["CK07"] = 1;
          }
          if(preg_match("/^\s\/dev\/[sh]d[a-z][0-9][\s]+[0-9\.KMG]+[\s]+[0-9\.KMG]+[\s]+[0-9\.KMG]+[\s]+([0-9]+)\%.*/",$b,$mat)){
            if($mat[1] >= 50){
              $srv_data[$k]["CK08"] = 1;
            }
          }
        }
        $srv_data[$k]["rcv_date"]  = $logdata["rcv_date"];
        $srv_data[$k]["memo_cd"]   = $logdata["memo_cd"];
        $srv_data[$k]["memo_date"] = $logdata["memo_date"];
        $old_key = $new_key;
      }
      return $srv_data;
    }


    /**
     * send to Dead Server report
     *
     * @param array $rcv_data the mail received data
     */
    function makeDeadSrvReport($rcv_date) {
      $srv_data = array();
      $res = $this->sql->query("select srv_cd,srv_name,eth0_ipaddr,router_flag from mst_server where hourly_flag = 't' order by srv_name ",
                       SQL_ALL,
                       SQL_ASSOC
                );
      if($res === FALSE){
        return FALSE;
      }
      $srv_data = $this->sql->record;
      $offset = 0;
      $new_key = "";
      $old_key = $new_key;
      $buff = array();
      foreach($srv_data as $k=>$v){
        $logdata = null;
        $sql = "select sirial,srv_cd,srv_name,rcv_date,mbody from logs_hourly where rcv_date like '$rcv_date%' and srv_cd = '".$v["srv_cd"]."' order by rcv_date desc limit 1 ";
        $res = $this->sql->query(
                      $sql,
                       SQL_INIT,
                       SQL_ASSOC
                );
        if($res === FALSE){
          return FALSE;
        }
        $logdata =  $this->sql->record;
        if($logdata["sirial"] == ""){
          $buff[$k]["srv_name"]    = $v["srv_name"];
          $buff[$k]["eth0_ipaddr"] = "(".$v["eth0_ipaddr"].")";
          $buff[$k]["cpu"]         = "";
          $buff[$k]["mem"]         = "";
          $buff[$k]["sta"]         = "down";
        }else{
          if($v["router_flag"] == "t"){
            $rows = explode("\n",$logdata["mbody"]);
            if(is_array($rows)){
              foreach($rows as $row){
                if(preg_match("/^[A-Za-z]{3}\s.?[0-9]{1,2}\s[0-9]{2}\:[0-9]{2}\:[0-9]{2}\s(localhost)\s(system)\:\s(cpu\:)([0-9\.].*)\s(mem\:)([0-9].*)\s(session).*$/",$row,$m)){
                  if(intval($m[4]) >= 1){
                    $buff[$k]["srv_name"]    = $v["srv_name"];
                    $buff[$k]["eth0_ipaddr"] = "(".$v["eth0_ipaddr"].")";
                    $buff[$k]["cpu"]         = "cpu:".$m[4];
                    $buff[$k]["mem"]         = "mem:".$m[6];
                    $buff[$k]["sta"]         = "over";
                    break;
                  }
                }
              }
            }
          }
        }
      }
      return $buff;
    }


}
?>
