<?php
/*
 * $Id: install_routerbook.php,v 1.1.1.1 2008/06/11 02:14:11 ikuma Exp $
 */

// include the setup script
include('../libs/server_manager.lib.php');
//start the session
session_name(SERVER_MANAGER_SES_NAME);
session_cache_limiter('nocache');
session_start();
// check the session
if($_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'] == ""){
  header("Content-type: text/plain; charset=UTF-8");
  print "Your access denied.";
  exit;
}

header("Content-type: application/xml");
print '<?xml version="1.0" encoding="utf-8"?>';
?>
<!DOCTYPE xsl:stylesheet [<!ENTITY nbsp "&#160;" >]>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lxslt="http://xml.apache.org/xslt" version="1.0">
  <xsl:template match="/">
    <html>
      <head>
        <title><xsl:value-of select="//Header/@title" /></title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <meta http-equiv="pragma" content="no-cache" />
        <meta http-equiv="cache-control" content="no-cache" />
        <meta equiv="expires" content="0" />
        <link href="css/servermanager.css" type="text/css" rel="stylesheet" />
      </head>
      <body class="fontS">
        <table border="1" class="list">
          <tr class="midasi">
            <th colspan="7">Router Entries for Install Logs
              [<a href="index.php?status=view">return to main menu</a>]
              [<a href="index.php?status=view_install_router&amp;flg=dsp">show all routerbook</a>]
              [<a href="index.php?status=view_install_router">show regular routerbook </a>]
            </th>
          </tr>
          <tr class="rec_2">
            <td>srv_cd</td>
            <td>srv_name</td>
            <td>os</td>
            <td>eth0_ipaddr</td>
            <td>default_gateway</td>
            <td>eth1_ipaddr</td>
            <td>eth2_ipaddr</td>
          </tr>
          <xsl:choose>
            <xsl:when test="count(//@srv_cd) != 0">
              <xsl:apply-templates select="//Records" />
            </xsl:when>
            <xsl:otherwise>
              <td colspan="7">No record</td>
            </xsl:otherwise>
          </xsl:choose>
        </table>
      </body>
    </html>
  </xsl:template>
  <xsl:template match="//Records">
    <xsl:variable name="srv_cd" select="@srv_cd" />
    <tr nowrap="nowrap">
    <xsl:choose>
      <xsl:when test="position() mod 2 = 0">
        <xsl:attribute name="class">rec_2</xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="class">rec_1</xsl:attribute>
      </xsl:otherwise>
    </xsl:choose>
      <td align="right"><a href="index.php?status=view_router_logs&amp;srv_cd={$srv_cd}"><xsl:value-of select="@srv_cd" /></a></td>
      <td>&nbsp;<xsl:value-of select="srv_name" /></td>
      <td>&nbsp;<xsl:value-of select="os" /></td>
      <td>&nbsp;<xsl:value-of select="eth0_ipaddr" /></td>
      <td>&nbsp;<xsl:value-of select="default_gateway" /></td>
      <td>&nbsp;<xsl:value-of select="eth1_ipaddr" /></td>
      <td>&nbsp;<xsl:value-of select="eth2_ipaddr" /></td>
    </tr>
  </xsl:template>
</xsl:stylesheet>
