<?php
/*
 * $Id: search_server_new_list.php,v 1.1.1.1 2008/06/11 02:14:11 ikuma Exp $
 */

// include the setup script
include('../libs/server_manager.lib.php');
//start the session
session_name(SERVER_MANAGER_SES_NAME);
session_cache_limiter('nocache');
session_start();
// check the session
if($_SESSION[SERVER_MANAGER_SES_NAME]['usr_cd'] == ""){
  header("Content-type: text/plain; charset=UTF-8");
  print "Your access denied.";
  exit;
}
// class
$user_class = $_SESSION[SERVER_MANAGER_SES_NAME]["user_class"];

header("Content-type: application/xml");
print '<?xml version="1.0" encoding="utf-8"?>';
?>
<!DOCTYPE xsl:stylesheet [<!ENTITY nbsp "&#160;" >]>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lxslt="http://xml.apache.org/xslt" version="1.0">
  <xsl:template match="/">
    <html>
      <head>
        <title><xsl:value-of select="//Header/@title" /></title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
        <meta http-equiv="pragma" content="no-cache" />
        <meta http-equiv="cache-control" content="no-cache" />
        <meta equiv="expires" content="0" />
        <link href="css/servermanager.css" type="text/css" rel="stylesheet" />
      </head>
      <body class="fontM">
      <?php if($user_class > 2){ ?>
        <form action="index.php" method="post">
          <table border="1" class="list">
            <tr class="midasi">
              <th colspan="6">Search Server Install Log Lists
                <input type="hidden" name="status" value="search_install_logs" />
                <input type="hidden" name="n_key_word" value="{//Entry/n_key_word}" />
                <input type="hidden" name="n_sea_opt" value="{//Entry/n_sea_opt}" />
                <input type="hidden" name="srv_cd" value="{//Entry/srv_cd}" />
                [<input type="submit" value="return to" />Set Key Word For Search Install Logs]
                [  Search Word  :  <xsl:value-of select="//Entry/n_key_word" />  ]
              </th>
            </tr>
          </table>
        </form>
        <table border="1" class="list">
          <tr class="rec_0">
            <td>kbn</td>
            <td>sirial</td>
            <td>srv_name</td>
            <td>rcv_date</td>
            <td>subject</td>
            <td>set_cd</td>
          </tr>
          <xsl:choose>
            <xsl:when test="count(//Records/@kbn) != 0">
              <xsl:apply-templates select="//Records" />
            </xsl:when>
            <xsl:otherwise>
              <td colspan="7">No record</td>
            </xsl:otherwise>
          </xsl:choose>
        </table>
      <?php } ?>
      </body>
    </html>
  </xsl:template>
<?php if($user_class > 2){ ?>
  <xsl:template match="Records">
    <tr nowrap="nowrap">
    <xsl:choose>
      <xsl:when test="position() mod 2 = 0">
        <xsl:attribute name="class">rec_2</xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="class">rec_1</xsl:attribute>
      </xsl:otherwise>
    </xsl:choose>
      <td>
        <xsl:choose>
          <xsl:when test="@kbn = '1'">LogWatch</xsl:when>
          <xsl:when test="@kbn = '2'">TripWire</xsl:when>
          <xsl:when test="@kbn = '3'">Cron</xsl:when>
        </xsl:choose>
      </td>
      <td align="right">
        <form action="index.php" method="post">
          <input type="hidden" name="status" value="show_server_log_new" />
          <input type="hidden" name="n_key_word" value="{//Entry/n_key_word}" />
          <input type="hidden" name="n_sea_opt" value="{//Entry/n_sea_opt}" />
          <input type="hidden" name="srv_cd" value="{//Entry/srv_cd}" />
          <input type="hidden" name="kbn" value="{@kbn}" />
          <input type="hidden" name="sirial" value="{sirial}" />
          <input type="submit" value="{sirial}" />
        </form>
      </td>
      <td><xsl:value-of select="srv_name" /></td>
      <td><xsl:value-of select="rcv_date" /></td>
      <td><xsl:value-of select="subject" /></td>
      <td><xsl:value-of select="set_cd" /></td>
    </tr>
  </xsl:template>
<?php } ?>
</xsl:stylesheet>
